"use strict";

function _typeof(obj) { "@babel/helpers - typeof"; return _typeof = "function" == typeof Symbol && "symbol" == typeof Symbol.iterator ? function (obj) { return typeof obj; } : function (obj) { return obj && "function" == typeof Symbol && obj.constructor === Symbol && obj !== Symbol.prototype ? "symbol" : typeof obj; }, _typeof(obj); }

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports["default"] = void 0;

var _react = _interopRequireDefault(require("react"));

var _propTypes = require("./props/propTypes");

var _defaultProps = require("./props/defaultProps");

var _MultiSelect = require("./MultiSelect");

var _Popup = _interopRequireDefault(require("../Popup/Popup"));

var _TextBoxIcon = _interopRequireDefault(require("../TextBoxIcon/TextBoxIcon"));

var _Layout = require("../Layout");

var _Card = _interopRequireWildcard(require("../Card/Card"));

var _SelectedOptions = _interopRequireDefault(require("./SelectedOptions"));

var _Suggestions = _interopRequireDefault(require("./Suggestions"));

var _EmptyState = _interopRequireDefault(require("./EmptyState"));

var _MultiSelectHeader = _interopRequireDefault(require("./MultiSelectHeader"));

var _CssProvider = _interopRequireDefault(require("../Provider/CssProvider"));

var _IdProvider = require("../Provider/IdProvider");

var _ResponsiveDropBox = _interopRequireDefault(require("../ResponsiveDropBox/ResponsiveDropBox"));

var _CustomResponsive = require("../Responsive/CustomResponsive");

var _Loader = _interopRequireDefault(require("@zohodesk/svg/lib/Loader/Loader"));

var _icons = require("@zohodesk/icons");

var _MultiSelectModule = _interopRequireDefault(require("./MultiSelect.module.css"));

function _getRequireWildcardCache(nodeInterop) { if (typeof WeakMap !== "function") return null; var cacheBabelInterop = new WeakMap(); var cacheNodeInterop = new WeakMap(); return (_getRequireWildcardCache = function _getRequireWildcardCache(nodeInterop) { return nodeInterop ? cacheNodeInterop : cacheBabelInterop; })(nodeInterop); }

function _interopRequireWildcard(obj, nodeInterop) { if (!nodeInterop && obj && obj.__esModule) { return obj; } if (obj === null || _typeof(obj) !== "object" && typeof obj !== "function") { return { "default": obj }; } var cache = _getRequireWildcardCache(nodeInterop); if (cache && cache.has(obj)) { return cache.get(obj); } var newObj = {}; var hasPropertyDescriptor = Object.defineProperty && Object.getOwnPropertyDescriptor; for (var key in obj) { if (key !== "default" && Object.prototype.hasOwnProperty.call(obj, key)) { var desc = hasPropertyDescriptor ? Object.getOwnPropertyDescriptor(obj, key) : null; if (desc && (desc.get || desc.set)) { Object.defineProperty(newObj, key, desc); } else { newObj[key] = obj[key]; } } } newObj["default"] = obj; if (cache) { cache.set(obj, newObj); } return newObj; }

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { "default": obj }; }

function _extends() { _extends = Object.assign ? Object.assign.bind() : function (target) { for (var i = 1; i < arguments.length; i++) { var source = arguments[i]; for (var key in source) { if (Object.prototype.hasOwnProperty.call(source, key)) { target[key] = source[key]; } } } return target; }; return _extends.apply(this, arguments); }

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

function _defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ("value" in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } }

function _createClass(Constructor, protoProps, staticProps) { if (protoProps) _defineProperties(Constructor.prototype, protoProps); if (staticProps) _defineProperties(Constructor, staticProps); Object.defineProperty(Constructor, "prototype", { writable: false }); return Constructor; }

function _inherits(subClass, superClass) { if (typeof superClass !== "function" && superClass !== null) { throw new TypeError("Super expression must either be null or a function"); } subClass.prototype = Object.create(superClass && superClass.prototype, { constructor: { value: subClass, writable: true, configurable: true } }); Object.defineProperty(subClass, "prototype", { writable: false }); if (superClass) _setPrototypeOf(subClass, superClass); }

function _setPrototypeOf(o, p) { _setPrototypeOf = Object.setPrototypeOf ? Object.setPrototypeOf.bind() : function _setPrototypeOf(o, p) { o.__proto__ = p; return o; }; return _setPrototypeOf(o, p); }

function _createSuper(Derived) { var hasNativeReflectConstruct = _isNativeReflectConstruct(); return function _createSuperInternal() { var Super = _getPrototypeOf(Derived), result; if (hasNativeReflectConstruct) { var NewTarget = _getPrototypeOf(this).constructor; result = Reflect.construct(Super, arguments, NewTarget); } else { result = Super.apply(this, arguments); } return _possibleConstructorReturn(this, result); }; }

function _possibleConstructorReturn(self, call) { if (call && (_typeof(call) === "object" || typeof call === "function")) { return call; } else if (call !== void 0) { throw new TypeError("Derived constructors may only return object or undefined"); } return _assertThisInitialized(self); }

function _assertThisInitialized(self) { if (self === void 0) { throw new ReferenceError("this hasn't been initialised - super() hasn't been called"); } return self; }

function _isNativeReflectConstruct() { if (typeof Reflect === "undefined" || !Reflect.construct) return false; if (Reflect.construct.sham) return false; if (typeof Proxy === "function") return true; try { Boolean.prototype.valueOf.call(Reflect.construct(Boolean, [], function () {})); return true; } catch (e) { return false; } }

function _getPrototypeOf(o) { _getPrototypeOf = Object.setPrototypeOf ? Object.getPrototypeOf.bind() : function _getPrototypeOf(o) { return o.__proto__ || Object.getPrototypeOf(o); }; return _getPrototypeOf(o); }

/*eslint-disable  react/sort-prop-types*/

/* eslint-disable react/forbid-component-props */

/* eslint-disable react/no-unused-prop-types */
var MultiSelectWithAvatarComponent = /*#__PURE__*/function (_MultiSelectComponent) {
  _inherits(MultiSelectWithAvatarComponent, _MultiSelectComponent);

  var _super = _createSuper(MultiSelectWithAvatarComponent);

  function MultiSelectWithAvatarComponent(props) {
    var _this;

    _classCallCheck(this, MultiSelectWithAvatarComponent);

    _this = _super.call(this, props);
    _this.handleFormatOptions = _this.handleFormatOptions.bind(_assertThisInitialized(_this));
    _this.getNextAriaId = (0, _IdProvider.getUniqueId)(_assertThisInitialized(_this));
    return _this;
  }

  _createClass(MultiSelectWithAvatarComponent, [{
    key: "handleFormatOptions",
    value: function handleFormatOptions(props) {
      var options = props.options,
          valueField = props.valueField,
          textField = props.textField,
          imageField = props.imageField,
          disabledOptions = props.disabledOptions;
      return this.formatOptions({
        options: options,
        valueField: valueField,
        textField: textField,
        imageField: imageField,
        optionType: 'avatar',
        disabledOptions: disabledOptions
      });
    }
  }, {
    key: "responsiveFunc",
    value: function responsiveFunc(_ref) {
      var mediaQueryOR = _ref.mediaQueryOR;
      return {
        tabletMode: mediaQueryOR([{
          maxWidth: 700
        }])
      };
    }
  }, {
    key: "render",
    value: function render() {
      var _this2 = this;

      var _this$props = this.props,
          isReadOnly = _this$props.isReadOnly,
          needSelectAll = _this$props.needSelectAll,
          searchEmptyMessage = _this$props.searchEmptyMessage,
          emptyMessage = _this$props.emptyMessage,
          noMoreOptionsMessage = _this$props.noMoreOptionsMessage,
          dropBoxSize = _this$props.dropBoxSize,
          placeHolder = _this$props.placeHolder,
          isPopupOpen = _this$props.isPopupOpen,
          isPopupReady = _this$props.isPopupReady,
          position = _this$props.position,
          defaultDropBoxPosition = _this$props.defaultDropBoxPosition,
          selectAllText = _this$props.selectAllText,
          getContainerRef = _this$props.getContainerRef,
          removeClose = _this$props.removeClose,
          isAnimate = _this$props.isAnimate,
          animationStyle = _this$props.animationStyle,
          textBoxSize = _this$props.textBoxSize,
          variant = _this$props.variant,
          size = _this$props.size,
          isDisabled = _this$props.isDisabled,
          title = _this$props.title,
          dataId = _this$props.dataId,
          dataSelectorId = _this$props.dataSelectorId,
          needResponsive = _this$props.needResponsive,
          borderColor = _this$props.borderColor,
          textBoxClass = _this$props.textBoxClass,
          needBorder = _this$props.needBorder,
          disableAction = _this$props.disableAction,
          palette = _this$props.palette,
          htmlId = _this$props.htmlId,
          i18nKeys = _this$props.i18nKeys,
          a11y = _this$props.a11y,
          children = _this$props.children,
          customChildrenClass = _this$props.customChildrenClass,
          isBoxPaddingNeed = _this$props.isBoxPaddingNeed,
          needEffect = _this$props.needEffect,
          isLoading = _this$props.isLoading,
          keepSelectedOptions = _this$props.keepSelectedOptions,
          customProps = _this$props.customProps;
      var _customProps$TextBoxP = customProps.TextBoxProps,
          TextBoxProps = _customProps$TextBoxP === void 0 ? {} : _customProps$TextBoxP,
          _customProps$Suggesti = customProps.SuggestionsProps,
          SuggestionsProps = _customProps$Suggesti === void 0 ? {} : _customProps$Suggesti;
      var _i18nKeys = i18nKeys,
          _i18nKeys$clearText = _i18nKeys.clearText,
          clearText = _i18nKeys$clearText === void 0 ? 'Clear all' : _i18nKeys$clearText;
      var _a11y$clearLabel = a11y.clearLabel,
          clearLabel = _a11y$clearLabel === void 0 ? 'Clear all' : _a11y$clearLabel;
      i18nKeys = Object.assign({}, i18nKeys, {
        emptyText: i18nKeys.emptyText || emptyMessage,
        searchEmptyText: i18nKeys.searchEmptyText || searchEmptyMessage,
        noMoreText: i18nKeys.noMoreText || noMoreOptionsMessage
      });
      var _this$state = this.state,
          selectedOptions = _this$state.selectedOptions,
          searchStr = _this$state.searchStr,
          hoverOption = _this$state.hoverOption,
          highLightedSelectOptions = _this$state.highLightedSelectOptions,
          options = _this$state.options,
          isFetchingOptions = _this$state.isFetchingOptions,
          isActive = _this$state.isActive,
          selectedOptionIds = _this$state.selectedOptionIds;
      var suggestions = this.handleFilterSuggestions();
      var setAriaId = this.getNextAriaId();
      var ariaErrorId = this.getNextAriaId();
      var popUpState = !isReadOnly && !isDisabled && !disableAction && isPopupOpen;
      var isShowClearIcon = !isReadOnly && !isDisabled && !disableAction && selectedOptions.length > 1;
      return /*#__PURE__*/_react["default"].createElement("div", {
        className: " ".concat(_MultiSelectModule["default"].wrapper, " ").concat(isDisabled ? _MultiSelectModule["default"].disabled : '', " ").concat(isReadOnly ? _MultiSelectModule["default"].readOnly : '', " ").concat(disableAction ? (0, _CssProvider["default"])('isBlock') : '', " ").concat(borderColor === 'transparent' ? _MultiSelectModule["default"].transparentContainer : '', " ").concat(needEffect && !(isDisabled || isReadOnly) ? _MultiSelectModule["default"].effect : ''),
        "data-id": "".concat(isDisabled ? "".concat(dataId, "_disabled") : isReadOnly ? "".concat(dataId, "_readOnly") : dataId),
        "data-test-id": "".concat(isDisabled ? "".concat(dataId, "_disabled") : isReadOnly ? "".concat(dataId, "_readOnly") : dataId),
        "data-title": isDisabled ? title : null,
        onClick: this.handleInputFocus,
        "data-selector-id": dataSelectorId
      }, /*#__PURE__*/_react["default"].createElement(_Layout.Container, {
        align: "vertical",
        alignBox: "row",
        className: "".concat(_MultiSelectModule["default"].container, "  ").concat(_MultiSelectModule["default"][size], " ").concat(needBorder ? _MultiSelectModule["default"]["borderColor_".concat(borderColor)] : '', " ").concat(isActive && needBorder ? _MultiSelectModule["default"].active : '', " ").concat(textBoxClass ? textBoxClass : '', " ").concat(needBorder ? _MultiSelectModule["default"].hasBorder : ''),
        eleRef: this.selectedOptionContainerRef,
        wrap: "wrap"
      }, /*#__PURE__*/_react["default"].createElement(_SelectedOptions["default"], {
        selectedOptions: selectedOptions,
        highLightedSelectOptions: highLightedSelectOptions,
        isReadOnly: isReadOnly,
        getRef: this.selectedOptionRef,
        onRemove: this.handleRemoveOption,
        onSelect: this.handleClickSelectedOption,
        size: size,
        palette: palette
      }), /*#__PURE__*/_react["default"].createElement(_Layout.Box, {
        flexible: true,
        className: _MultiSelectModule["default"].wrapper,
        adjust: true,
        shrink: true
      }, /*#__PURE__*/_react["default"].createElement("span", {
        className: " ".concat(_MultiSelectModule["default"].custmSpan, " ").concat(textBoxSize === 'xmedium' ? _MultiSelectModule["default"].custmSpanXmedium : _MultiSelectModule["default"].custmSpanMedium, " ").concat(isShowClearIcon ? _MultiSelectModule["default"].clearIconSpace : '', "\n               ").concat(customChildrenClass ? customChildrenClass : '')
      }, searchStr), /*#__PURE__*/_react["default"].createElement(_TextBoxIcon["default"], {
        isDisabled: isDisabled,
        inputRef: this.searchInputRef,
        needBorder: false,
        onBlur: this.handleInactive,
        onChange: this.handleSearch,
        onClick: this.handleInputCick,
        onFocus: this.handleActive,
        onKeyDown: this.handleKeyDown,
        placeHolder: selectedOptions.length >= 1 ? '' : placeHolder,
        size: textBoxSize,
        value: searchStr,
        variant: variant,
        dataId: "".concat(dataId, "_textBox"),
        isReadOnly: isReadOnly,
        tabindex: isDisabled && '-1',
        htmlId: htmlId,
        a11y: {
          ariaExpanded: popUpState ? true : false,
          ariaHaspopup: true,
          role: 'combobox',
          ariaControls: setAriaId,
          ariaOwns: setAriaId,
          ariaDescribedby: ariaErrorId
        },
        customClass: {
          customTBoxWrap: _MultiSelectModule["default"].custmInputWrapper
        },
        autoComplete: false,
        customProps: {
          TextBoxProps: TextBoxProps
        }
      }, /*#__PURE__*/_react["default"].createElement(_Layout.Container, {
        isCover: false,
        alignBox: "row",
        align: "vertical",
        className: _MultiSelectModule["default"].iconContainer
      }, children ? /*#__PURE__*/_react["default"].createElement(_Layout.Box, {
        dataId: "".concat(dataId, "_children")
      }, children) : null, isShowClearIcon ? /*#__PURE__*/_react["default"].createElement(_Layout.Box, {
        className: "".concat(_MultiSelectModule["default"]["delete"], " ").concat(_MultiSelectModule["default"]["".concat(palette, "Delete")]),
        dataId: "".concat(dataId, "_clearIcon"),
        "data-title": clearText,
        onClick: this.handleDeselectAll,
        tagName: "button",
        "aria-label": clearLabel
      }, /*#__PURE__*/_react["default"].createElement(_icons.Icon, {
        name: "ZD-delete",
        size: "15"
      })) : null)))), popUpState ? /*#__PURE__*/_react["default"].createElement(_CustomResponsive.ResponsiveReceiver, {
        query: this.responsiveFunc,
        responsiveId: "Helmet"
      }, function (_ref2) {
        var tabletMode = _ref2.tabletMode;
        return /*#__PURE__*/_react["default"].createElement(_ResponsiveDropBox["default"], {
          animationStyle: animationStyle,
          boxPosition: position || "".concat(defaultDropBoxPosition, "Center"),
          getRef: getContainerRef,
          isActive: isPopupReady,
          isAnimate: isAnimate,
          isArrow: false,
          onClick: removeClose,
          needResponsive: needResponsive,
          isPadding: false,
          isBoxPaddingNeed: isBoxPaddingNeed,
          palette: palette,
          htmlId: setAriaId,
          a11y: {
            ariaMultiselectable: true,
            role: 'listbox'
          },
          isResponsivePadding: true,
          alignBox: "row"
        }, /*#__PURE__*/_react["default"].createElement(_Layout.Box, {
          flexible: true
        }, /*#__PURE__*/_react["default"].createElement(_Card["default"], {
          customClass: "".concat(_MultiSelectModule["default"].box, " ").concat(_MultiSelectModule["default"]["".concat(palette, "Box")]),
          onScroll: _this2.handleScroll
        }, /*#__PURE__*/_react["default"].createElement(_Card.CardHeader, null, /*#__PURE__*/_react["default"].createElement(_MultiSelectHeader["default"], {
          needSelectAll: needSelectAll,
          onSelect: _this2.handleSelectAll,
          selectAllText: selectAllText,
          suggestions: suggestions,
          dataId: dataId
        })), isLoading ? /*#__PURE__*/_react["default"].createElement(_Layout.Container, {
          align: "both",
          className: _MultiSelectModule["default"].loader
        }, /*#__PURE__*/_react["default"].createElement(_Loader["default"], null)) : /*#__PURE__*/_react["default"].createElement(_Card.CardContent, {
          shrink: true,
          customClass: !tabletMode && dropBoxSize ? _MultiSelectModule["default"][dropBoxSize] : '',
          eleRef: _this2.suggestionContainerRef
        }, suggestions.length ? /*#__PURE__*/_react["default"].createElement(_Suggestions["default"], _extends({
          needTick: keepSelectedOptions,
          suggestions: suggestions,
          getRef: _this2.suggestionItemRef,
          hoverOption: hoverOption,
          onClick: _this2.handleSelectOption,
          onMouseEnter: _this2.handleMouseEnter,
          needBorder: false,
          dataId: "".concat(dataId, "_Options"),
          palette: palette,
          selectedOptions: selectedOptionIds,
          a11y: {
            role: 'option'
          }
        }, SuggestionsProps)) : /*#__PURE__*/_react["default"].createElement(_EmptyState["default"], {
          isLoading: isFetchingOptions,
          options: options,
          searchString: searchStr,
          suggestions: suggestions,
          dataId: dataId,
          palette: palette,
          i18nKeys: i18nKeys,
          htmlId: ariaErrorId
        }), isFetchingOptions && /*#__PURE__*/_react["default"].createElement(_Layout.Container, {
          isCover: false,
          align: "both"
        }, /*#__PURE__*/_react["default"].createElement(_Loader["default"], null))))));
      }) : null);
    }
  }]);

  return MultiSelectWithAvatarComponent;
}(_MultiSelect.MultiSelectComponent);

MultiSelectWithAvatarComponent.propTypes = _propTypes.MultiSelectWithAvatar_propTypes;
MultiSelectWithAvatarComponent.defaultProps = _defaultProps.MultiSelectWithAvatar_defaultProps;
MultiSelectWithAvatarComponent.displayName = 'MultiSelectWithAvatar';
var MultiSelectWithAvatar = (0, _Popup["default"])(MultiSelectWithAvatarComponent);
MultiSelectWithAvatar.defaultProps = MultiSelectWithAvatarComponent.defaultProps; // if (__DOCS__) {
//   MultiSelectWithAvatarComponent.docs = {
//     componentGroup: 'Form Elements',
//     folderName: 'Style Guide'
//   };
//   // eslint-disable-next-line react/forbid-foreign-prop-types
//   MultiSelectWithAvatar.propTypes = MultiSelectWithAvatarComponent.propTypes;
// }

var _default = MultiSelectWithAvatar;
exports["default"] = _default;